#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct tree
{
	char color[10];
	char shape[10];
	int num;
	int num2;
	int balance;
	struct tree *left, *right;
} tree;

#define new(x) x = (tree *)malloc(sizeof(tree))

void lrotation(tree **);
void rrotation(tree **);
tree *form(int );
int add(tree **, char *, char *);
void fix(tree **);
tree *find(tree **);
tree *delete(tree *, char *);
int col(char *);
int col1(char *);
int depth(tree *);
void print(tree *);
void numb(tree *, char *, int *);

int depth(tree *p)
{
	int dr = 0, dl = 0;
	if(p->left) dl = depth(p->left);
	if(p->right) dr = depth(p->right);
	if(dl > dr) return ++dl;
	else return ++dr;
}

void lrotation(tree **p)
{
	tree *poml, *pomr;

	poml = *p;
	pomr = poml->right;
	poml->right = pomr->left;
	pomr->left = poml;
	*p = pomr;

	poml->balance = depth(poml->right) - depth(poml->left);
	pomr->balance = depth(pomr->right) - depth(pomr->right);
}

void rrotation(tree **p)
{
	tree *poml, *pomr;

	pomr = *p;
	poml = pomr->left;
	pomr->left = poml->right;
	poml->right = pomr;
	*p = poml;

	poml->balance = depth(poml->right) - depth(poml->left);
	pomr->balance = depth(pomr->right) - depth(pomr->right);
}

int col(char *s)
{
	if(!strcmp(s, "srebrna")) return 1;
	if(!strcmp(s, "crvena")) return 2;
	if(!strcmp(s, "zlatna")) return 3;
}

int col1(char *s)
{
	if(!strcmp(s, "ssfera")) return 1;
	if(!strcmp(s, "kocka")) return 2;
}

int add(tree **p, char *b, char *o)
{
	tree *t = *p;
	int k, l, inc, res;

	res = 0;
	
	if(!t)
	{
		new(t);
		strcpy(t->color, b);
		t->num = col(b);
		strcpy(t->shape, o);
		t->num2 = col1(o);
		t->right = t->left = NULL;
		t->balance = 0;
		res = 1;
	}
	else
	{
		k = col(b);
		l = col1(o);
		if(k == t->num)
		{
			if(l > t->num2) inc = add(&(t->right), b, o);
			else inc = - add(&(t->left), b, o);
		}
		else if(k > t->num) inc = add(&(t->right), b, o);
		else inc = - add(&(t->left), b, o);
		t->balance += inc;

		if((inc != 0) && (t->balance != 0))
		{
			if(t->balance < -1)
			{
				if(t->left->balance < 0) rrotation(&t);
				else
				{
					lrotation(&(t->left));
					rrotation(&t);
				}
			}
			if(t->balance > 1)
			{
				if(t->right->balance > 0) lrotation(&t);
				else
				{
					rrotation(&(t->right));
					lrotation(&t);
				}
			}
		}
		else res = 1;
	}
	*p = t;
	return res;
}

tree *form(int n)
{
	char b[10], o[10];
	int i;
	tree *p = NULL;

	for(i = 0; i < n; i++)
	{
		printf("Unesi boju: ");
		gets(b);
		printf("Unesi oblik: ");
		gets(o);
		add(&p, b, o);
	}

	return p;
}

void print(tree *p)
{
	if(p)
	{
		print(p->left);
		printf("Boja: %s, oblik: %s, balans: %d\n", p->color, p->shape, p->balance);
		print(p->right);
	}
}

tree *find(tree **p)
{
	tree *pom, *res;
	pom = *p;

	if(!(pom->left))
	{
		res = pom;
		pom = pom->right;
	}
	else res = find(&(pom->left));
	if(pom)
	{
		pom->balance = depth(pom->right) - depth(pom->left);
		fix(&pom);
	}
	*p = pom;
	return res;
}

void fix(tree **p)
{
	tree *t;
	if(*p)
	{
		t = *p;
		if(t->balance < -1)
		{
			if(t->left->balance < 0) rrotation(&t);
			else
			{
				lrotation(&(t->left));
				rrotation(&t);
			}			}
		if(t->balance > 1)
		{
			if(t->right->balance > 0) lrotation(&t);
			else
			{
				rrotation(&(t->right));
				lrotation(&t);
			}
		}
		*p = t;	
	}
}

tree *delete(tree *p, char *s)
{
	tree *pom, *t;

	if(!p) return NULL;
	if(!strcmp(p->shape, s))
	{
		if(!(p->left) && !(p->right))
		{
			free(p);
			return NULL;
		}
		if(!(p->left) && (p->right))
		{
			pom = p->right;
			free(p);
			return pom;
		}
		if((p->left) && !(p->right))
		{
			pom = p->left;
			free(p);
			return pom;
		}
		if((p->left) && (p->right))
		{
			t = find(&(p->right));
			strcpy(p->color, t->color);
			strcpy(p->shape, t->shape);
			p->balance = depth(p->right) - depth(p->left);
			fix(&p);	
			return p;		
		}
	}

	p->left = delete(p->left, s);
	p->balance = depth(p->right) - depth(p->left);
	fix(&p);
	p->right = delete(p->right, s);
	p->balance = depth(p->right) - depth(p->left);
	fix(&p);
	return p;
}

void numb(tree *p, char *s, int *k)
{
	if(p)
	{
		numb(p->left, s, k);
		if(!strcmp(p->color, s)) (*k)++;
		numb(p->right, s, k);
	}
}

main()
{
	int n, k, nl, nr, i;
	char s[10], c[10];
	tree *p;

	printf("Unesite n: ");
	scanf("%d", &n);
	getchar();

	p = form(n);
	print(p);
	printf("\n");

	printf("aaaaaaaaaaaaaaaa\n");
	strcpy(s, p->shape);
	
	for(i = 0; i < n; i++)
		p = delete(p, s);

	printf("Boja na vrhu jelke je %s\n", p->color);
	numb(p->left, p->color, &nl);
	numb(p->left, p->color, &nr);
	if(nl == nr) printf("ima isto\n");
	else if(nl < nr) printf("ima vise desno\n");
	else printf("ima vise levo\n");
}
