#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef struct drvo
{
	char boja[8];
	char oblik[6];
	int col;
	struct drvo *ldr, *ddr, *pdr;
} drvo;

enum {RED,BLK};

void lrotacija(drvo **p1, drvo *p2)
{
	drvo *q;
		
	q = p2->ddr;
	
	p2->ddr = q->ldr;

	if(p2->ddr)
		p2->ddr->pdr = p2;
	q->pdr = p2->pdr;
	
	if(!q->pdr)
	 *p1 = q;
	else
	{
		if(p2->pdr->ldr == p2)
			q->pdr->ldr = q;
		else
			q->pdr->ddr = q;
	}
	q->ldr = p2;
	p2->pdr = q;
}


void drotacija(drvo **p1, drvo *p2)
{
	drvo *q;
	
	q = p2->ldr;
	p2->ldr = q->ddr;
	if(p2->ldr)
		p2->ldr->pdr = p2;
	
	q->pdr = p2->pdr;
	
	if(!q->pdr)
	 *p1 = q;
	else
	{
		if(p2->pdr->ldr == p2)
			q->pdr->ldr = q;
		else
			q->pdr->ddr = q;
	}
	q->ddr = p2;
	p2->pdr = q;
		
}

int boja(char* s)
{
	if(!strcmp(s,"srebrna"))
		return 1;
	if(!strcmp(s,"crvena"))
		return 2;
	if(!strcmp(s,"zlatna"))
		return 3;
}

int oblik(char *s)
{
	if(!strcmp(s,"sfera"))
		return 1;
	if(!strcmp(s,"kocka"))
		return 2;
}

int insert(drvo **p, char* b, char *o)
{
	drvo *q, *r;
	
	q = (drvo*)malloc(sizeof(drvo));
	q->col = RED;
	q->pdr = q->ldr = q->ddr = NULL;
	strcpy(q->boja, b);
	strcpy(q->oblik, o);
	if(!(*p))
	{
		*p = q;
		return 1;
	}
	
	r = *p;
	
	while(1)
	{
		if(boja(b) < boja(r->boja))
		{
			if(r->ldr)
				r = r->ldr;
			else
			{
				r->ldr = q;
				q->pdr = r;
				break;
			}	
		}
		else
		{
			if(boja(b) > boja(r->boja))
			{
				if(r->ddr)
					r = r->ddr;
				else
				{
					r->ddr = q;
					q->pdr = r;
					break;
				}
			}
			else
			if(boja(b) == boja(r->boja))
			{
				
				if(oblik(b) < oblik(r->oblik))
				{
					if(r->ldr)
						r = r->ldr;
					else
					{
						r->ldr = q;
						q->pdr = r;
						break;
					}
				}
				else
				{
					if(r->ddr)
						r = r->ddr;
					else
					{
						r->ddr = q;
						q->pdr = r;
						break;
					}
				}	
			}	
		}
	}
	while((q != *p) && (q->pdr != *p) && (q->pdr->col == RED))
	{

		if(q->pdr->pdr->ldr == q->pdr)
		{
		
			r = q->pdr->pdr->ddr;
			if((r != NULL) && (r->col == RED))
			{
				q->pdr->col = BLK;
				r->col = BLK;
				q = q->pdr->pdr;
				q->col = RED;
			}
			else
			{
				if(q->pdr->ddr == q)
				{
					q = q->pdr;
					lrotacija(p,q);
				}
				q->pdr->col = BLK;
				q->pdr->pdr->col = RED;
				drotacija(p,q->pdr->pdr);
			}
		}
		else
		{

			r = q->pdr->pdr->ldr;
			if((r != NULL) && (r->col == RED))
			{
				
				q->pdr->col = BLK;
				r->col = BLK;
				q = q->pdr->pdr;
				q->col = RED;						
			}
			else
			{			
				if(q->pdr->ldr == q)
				{
				
					q = q->pdr;
					drotacija(p,q);
									
				}			
				q->pdr->col = BLK;
				q->pdr->pdr->col = RED;				
				lrotacija(p,q->pdr->pdr);
			}
		}
	}
	(*p)->col = BLK;
	
}

void print(drvo *p)
{
	if(p)
	{
		print(p->ldr);
		printf("%s\t %s\t, ",p->boja,p->oblik);
		if(p->col == RED)
			printf("(RED)\n");
		else
			printf("(BLACK)\n");
		print(p->ddr);		
	}
}

void brisi(drvo** p, drvo *q, char* o)
{
	if(q != NULL)
	if(strcmp(q->oblik,o))
	{
		insert(p,q->boja,q->oblik);
		brisi(p,q->ldr,o);
		brisi(p,q->ddr,o);
	}
	else
	{
		brisi(p,q->ldr,o);
		brisi(p,q->ddr,o);
	}
	else	
		return;
}

void broj(drvo *p, int *br, char* b)
{
	if(p)
	{
		broj(p->ldr, br, b);
		if(!strcmp(p->boja, b))
			(*br)++;
		broj(p->ddr, br, b);
		
	}
}

int main(int argc, char** argv)
{
	drvo *p = NULL, *q = NULL;
	int n,l, brl = 0, brd = 0;
	FILE *f;
	char b[10];
	char o[10];
	
	f = fopen(argv[1],"r");
	if(!f)
	{
		printf("Greksa pri otvaranju datoteke!!\n");
		exit(1);
	}
	scanf("%d",&n);

	while(n)
	{
		fgets(b,sizeof(b),f);

		l = strlen(b) - 1;
		if(b[l] == '\n')
			b[l] = '\0';

		fgets(o,sizeof(o),f);
		l = strlen(o) - 1;
		if(o[l] == '\n')
			o[l] = '\0';
		insert(&p,b,o);
		n--;
	
	}
	print(p);
	printf("\n\n");
	printf("Vrh jelke oblik: %s\n", p->oblik);
	brisi(&q,p,p->oblik);
	if(q == NULL)
	{
		printf("Jelka je prazna posle brisanja!!\n");
		return 0;
	}	
	print(q);
	printf("\n\n");
	printf("Vrh jelke boja: %s\n", q->boja);
	
	if(q->ldr)
		broj(q->ldr,&brl,q->boja);	
	if(q->ddr)
		broj(q->ddr,&brd,q->boja);
		
	if(brl > brd)
		printf("Ima vise u levom!\n");
	else
	if(brd > brl)
		printf("Ima vise u desnom!\n");
	else
		printf("Ima isto!\n");
		
	return 0;
}











